rm(list=ls())
library(tidyverse);library(ggpubr);library(cowplot);library(dplyr);library(ggplot2);
library(viridis);library(grid);library(data.table)

setwd("~/OneDrive - University of Georgia/Blupf90_Examples/VCE/")

data <- fread("postgibbs_samples")
head(data)

ggline(data, x="V2", y="V6")
ggline(data, x="V2", y="V7")
ggline(data, x="V2", y="V8")
ggline(data, x="V2", y="V9")

ggdensity(data, x="V6", color="blue",fill="gray")
ggdensity(data, x="V7", color="blue",fill="gray")
ggdensity(data, x="V8", color="blue",fill="gray")
ggdensity(data, x="V9", color="blue",fill="gray")

gghistogram(data, x="V6",color="blue",fill="gray")
gghistogram(data, x="V7",color="blue",fill="gray")
gghistogram(data, x="V8",color="blue",fill="gray")
gghistogram(data, x="V9",color="blue",fill="gray")


library(extraDistr)
# Basic Gibbs sampling for mu (normal) and sigma2 (inverted chi-square)
y <- c(14,16,18,20,22,24,26,28,30,32,34,36,40)
N <- length(y)
n.samples <- 10000
mu <- rep(0,n.samples)
sigma2 <- rep(0,n.samples)

# initial value
mu[1] <- 0
sigma2[1] <- 10

# sampling
for(i in 2:n.samples){
  mu[i] <- rnorm(1, mean=mean(y), sd=sqrt(sigma2[i-1]/N)) # using the most recent sigma2
  df <- N-1
  S <- sum((y-mu[i])^2)/df
  sigma2[i] <- rinvchisq(1, nu=df, tau=S) # using the most recent mu
}

hist(mu)
hist(sigma2)
 
mean(y)
var(y)
